Save This Page
Home » spring-framework-2.5.5-with-dependencies » org.springframework » beans » support » [javadoc | source]
org.springframework.beans.support
public class: PagedListHolder [javadoc | source]
java.lang.Object
   org.springframework.beans.support.PagedListHolder

All Implemented Interfaces:
    Serializable

Direct Known Subclasses:
    RefreshablePagedListHolder

PagedListHolder is a simple state holder for handling lists of objects, separating them into pages. Page numbering starts with 0.

This is mainly targetted at usage in web UIs. Typically, an instance will be instantiated with a list of beans, put into the session, and exported as model. The properties can all be set/get programmatically, but the most common way will be data binding, i.e. populating the bean from request parameters. The getters will mainly be used by the view.

Supports sorting the underlying list via a SortDefinition implementation, available as property "sort". By default, a MutableSortDefinition instance will be used, toggling the ascending value on setting the same property again.

The data binding names have to be called "pageSize" and "sort.ascending", as expected by BeanWrapper. Note that the names and the nesting syntax match the respective JSTL EL expressions, like "myModelAttr.pageSize" and "myModelAttr.sort.ascending".

Field Summary
public static final  int DEFAULT_PAGE_SIZE     
public static final  int DEFAULT_MAX_LINKED_PAGES     
Constructor:
 public PagedListHolder() 
 public PagedListHolder(List source) 
    Create a new holder instance with the given source list, starting with a default sort definition (with "toggleAscendingOnProperty" activated).
    Parameters:
    source - the source List
    Also see:
    MutableSortDefinition#setToggleAscendingOnProperty
 public PagedListHolder(List source,
    SortDefinition sort) 
    Create a new holder instance with the given source list.
    Parameters:
    source - the source List
    sort - the SortDefinition to start with
Method from org.springframework.beans.support.PagedListHolder Summary:
copySortDefinition,   doSort,   getFirstElementOnPage,   getFirstLinkedPage,   getLastElementOnPage,   getLastLinkedPage,   getMaxLinkedPages,   getNrOfElements,   getPage,   getPageCount,   getPageList,   getPageSize,   getRefreshDate,   getSort,   getSource,   isFirstPage,   isLastPage,   nextPage,   previousPage,   resort,   setMaxLinkedPages,   setPage,   setPageSize,   setSort,   setSource
Methods from java.lang.Object:
equals,   getClass,   hashCode,   notify,   notifyAll,   toString,   wait,   wait,   wait
Method from org.springframework.beans.support.PagedListHolder Detail:
 protected SortDefinition copySortDefinition(SortDefinition sort) 
    Create a deep copy of the given sort definition, for use as state holder to compare a modified sort definition against.

    Default implementation creates a MutableSortDefinition instance. Can be overridden in subclasses, in particular in case of custom extensions to the SortDefinition interface. Is allowed to return null, which means that no sort state will be held, triggering actual sorting for each resort call.

 protected  void doSort(List source,
    SortDefinition sort) 
    Actually perform sorting of the given source list, according to the given sort definition.

    The default implementation uses Spring's PropertyComparator. Can be overridden in subclasses.

 public int getFirstElementOnPage() 
    Return the element index of the first element on the current page. Element numbering starts with 0.
 public int getFirstLinkedPage() 
    Return the first page to which create a link around the current page.
 public int getLastElementOnPage() 
    Return the element index of the last element on the current page. Element numbering starts with 0.
 public int getLastLinkedPage() 
    Return the last page to which create a link around the current page.
 public int getMaxLinkedPages() 
    Return the maximum number of page links to a few pages around the current one.
 public int getNrOfElements() 
    Return the total number of elements in the source list.
 public int getPage() 
    Return the current page number. Page numbering starts with 0.
 public int getPageCount() 
    Return the number of pages for the current source list.
 public List getPageList() 
    Return a sub-list representing the current page.
 public int getPageSize() 
    Return the current page size.
 public Date getRefreshDate() 
    Return the last time the list has been fetched from the source provider.
 public SortDefinition getSort() 
    Return the sort definition for this holder.
 public List getSource() 
    Return the source list for this holder.
 public boolean isFirstPage() 
    Return if the current page is the first one.
 public boolean isLastPage() 
    Return if the current page is the last one.
 public  void nextPage() 
    Switch to next page. Will stay on last page if already on last page.
 public  void previousPage() 
    Switch to previous page. Will stay on first page if already on first page.
 public  void resort() 
    Resort the list if necessary, i.e. if the current sort instance isn't equal to the backed-up sortUsed instance.

    Calls doSort to trigger actual sorting.

 public  void setMaxLinkedPages(int maxLinkedPages) 
    Set the maximum number of page links to a few pages around the current one.
 public  void setPage(int page) 
    Set the current page number. Page numbering starts with 0.
 public  void setPageSize(int pageSize) 
    Set the current page size. Resets the current page number if changed.

    Default value is 10.

 public  void setSort(SortDefinition sort) 
    Set the sort definition for this holder. Typically an instance of MutableSortDefinition.
 public  void setSource(List source) 
    Set the source list for this holder.